unit USerialNGXEBasicSettingsDlg;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  Buttons, ExtCtrls, USerialNGXE;

type
  TDlgSerialNGXEBasicSettings = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    CBPort: TComboBox;
    CBBaud: TComboBox;
    CBData: TComboBox;
    CBStop: TComboBox;
    CBParity: TComboBox;
    CBFlow: TComboBox;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetDlgData(const ASerialPortNGXE : TSerialPortNGXE);
    procedure GetDlgData(const ASerialPortNGXE : TSerialPortNGXE);
  end;
var
  DlgSerialNGXEBasicSettings: TDlgSerialNGXEBasicSettings;

implementation

{$R *.DFM}
procedure TDlgSerialNGXEBasicSettings.SetDLGData(const ASerialPortNGXE : TSerialPortNGXE);
var i : Integer;
begin
  i := CBPort.Items.IndexOf(ASerialPortNGXE.CommPort);
  if i >= 0 then
    CBPort.ItemIndex := i
  else
    CBPort.ItemIndex := 1; //COM2
  i := CBBaud.Items.IndexOf(IntToStr(ASerialPortNGXE.BaudRate));
  if i >= 0 then
    CBBaud.ItemIndex := i
  else
    CBBaud.ItemIndex := 6; // 9600
  i := CBData.Items.IndexOf(IntToStr(ASerialPortNGXE.DataBits)+' Bit');
  if i >= 0 then
    CBData.ItemIndex := i
  else
    CBData.ItemIndex := 4; // 8 Bit
  CBStop.ItemIndex := Byte(ASerialPortNGXE.StopBits);
  CBParity.ItemIndex := Byte(ASerialPortNGXE.ParityType);
  if ASerialPortNGXE.FlowControlFlags = fcNone then
    CBFlow.ItemIndex := 0
  else if ASerialPortNGXE.FlowControlFlags = fcXONXOFF then
    CBFlow.ItemIndex := 1
  else if ASerialPortNGXE.FlowControlFlags = fcRTSCTS then
    CBFlow.ItemIndex := 2
  else if ASerialPortNGXE.FlowControlFlags = fcDSRDTR then
    CBFlow.ItemIndex := 3
  else
    CBFlow.ItemIndex := 0;
end;

procedure TDlgSerialNGXEBasicSettings.GetDLGData(const ASerialPortNGXE : TSerialPortNGXE);
begin
  ASerialPortNGXE.CommPort := CBPort.Items[CBPort.ItemIndex];
  ASerialPortNGXE.BaudRate := StrToIntDef(CBBaud.Items[CBBaud.ItemIndex],9600);
  ASerialPortNGXE.DataBits := StrToIntDef(Copy(CBData.Items[CBData.ItemIndex],1,1),8);
  ASerialPortNGXE.StopBits := TSNXStopBits(CBStop.ItemIndex);
  ASerialPortNGXE.ParityType := TSNXParityType(CBParity.ItemIndex);
  case CBFlow.ItemIndex of
    0 : ASerialPortNGXE.FlowControlFlags := fcNone;
    1 : ASerialPortNGXE.FlowControlFlags := fcXONXOFF;
    2 : ASerialPortNGXE.FlowControlFlags := fcRTSCTS;
    3 : ASerialPortNGXE.FlowControlFlags := fcDSRDTR;
  end;
  ASerialPortNGXE.Active := True;
end;

end.
