unit USerialXEBasicDemoMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, USerialNGXE, Vcl.StdCtrls, UCommPortList;

type
  TForm1 = class(TForm)
    btnPortSettings: TButton;
    Label1: TLabel;
    edtStringToSend: TEdit;
    btnSend: TButton;
    Label2: TLabel;
    memoReceived: TMemo;
    Memo1: TMemo;
    Button1: TButton;
    procedure btnPortSettingsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    FSerialPortNGXE : TSerialPortNGXE;
    procedure OnRxClusterEvent(Sender : TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses USerialNGXEBasicSettingsDlg;

procedure TForm1.btnPortSettingsClick(Sender: TObject);
begin
  DlgSerialNGXEBasicSettings.SetDlgData(FSerialPortNGXE);
  if DlgSerialNGXEBasicSettings.ShowModal = mrOK then
    DlgSerialNGXEBasicSettings.GetDlgData(FSerialPortNGXE);
end;

procedure TForm1.btnSendClick(Sender: TObject);
begin
  FSerialPortNGXE.SendString(edtStringToSend.Text);
// Fr Unicode Strings sollte die Nachfolgende Methode verwendet werden
//  FSerialPortNGXE.SendUnicodeString(edtStringToSend.Text);
end;
procedure TForm1.Button1Click(Sender: TObject);
begin
  GetPortList(Memo1.Lines);
end;

procedure TForm1.OnRxClusterEvent(Sender : TObject);
begin
  MemoReceived.Lines.Add(FSerialPortNGXE.ReadNextClusterAsString);
// Fr Unicode Strings sollte die Nachfolgende Methode verwendet werden
//  MemoReceived.Lines.Add(FSerialPortNGXE.ReadNextClusterAsUnicodeString);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSerialPortNGXE := TSerialPortNGXE.Create(Self);
  FSerialPortNGXE.OnRxClusterEvent := OnRxClusterEvent;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FSerialPortNGXE.Active := False;
end;

end.
